/* Konfigurationsdateiinterpreter mit lex und yacc
   Headerdatei

											Datei: cfgdatei.h
											Datum: 26.11.1995
											Rev. : 01.10.1996
											Autor: KS
*/

#ifndef __CFGDATEI_H_INCLUDED__ /* Nur einmal einfgen */
#define __CFGDATEI_H_INCLUDED__

/* Konstanten */
#define TRUE  1
#define FALSE 0

 /* Optionen */
#define MEHR           1 /* Zustzliche Eintrge sind erlaubt */
#define GROSSKLEINEGAL 2 /* Gro- Kleinschreibung egal */
#define ABSCHNITTE     4 /* Namen aller vorhandenen Abschnitte holen */

 /* Fehlermeldungen */
#ifndef F_SPEICHER
 #define F_SPEICHER "Nicht genug Speicherplatz vorhanden!"
#endif
#ifndef F_BEZEICHNER
 #define F_BEZEICHNER "Unbekannter Bezeichner"
#endif
#ifndef F_TYP
 #define F_TYP "Falscher Typ des Wertes von Bezeichner"
#endif
#ifndef F_BEZ_WERT
 #define F_BEZ_WERT "Unbekannter Bezeichnerwert"
#endif
#ifndef F_ABSCHNITT
 #define F_ABSCHNITT "Unbekannter Abschnitt"
#endif

 /* Typ ist egal */
#define EGAL 0


/* Typedefs */
typedef struct {
	char *bezeichner;
	int wert;
} BEZEICHNER_DEF;

typedef struct alle_abschnittdata {
	char *abschnitt;
	struct alle_abschnittdata *next;
} ALLE_ABSCHNITTE;

typedef struct {
	char *bezeichner; /* Bezeichner (Schlsselwort) */
	int typ;  /* Der Typ des Wertes */
	union {   /* Der Wert */
		char *string;
		char **string_ptr;
		long val;
		int *int_ptr;
		long *long_ptr;
	} werte;
	BEZEICHNER_DEF *def; /* Bezeichnerdefinitionen bei def. "Bezeichner = Bezeichner" */
} EINTRAEGE;

typedef struct {
	union {
		char *abschnitt;
		ALLE_ABSCHNITTE *alle_abschnitte;
	} abschnitt;
	unsigned char optionen;
	EINTRAEGE *eintraege;
} INHALT;


/* Funktionsprototypen */
 /* in cfgdatei.l */
void cfgdateilesen(FILE *,char *,INHALT *);
#ifdef ZEILEN_LESEN
void cfgdateizeilelesen(FILE *,char *,char *,char *,char **,int);
#endif
void warning(char *);
void yyerror(char *);
void yyexterror(char *,char *);
 /* in cfgdatei.y */
int keyword(char *,int *);
int abschnitte(char *);
int def_bezeichner(BEZEICHNER_DEF *,char *);
int string_compare(char *,char *);

#endif
