/* Ausgabe der empfangenen Daten

									Datei: ausgabe.c
									Datum: 01.09.1996
									Rev. : 27.04.1997
									Rev.2: 30.04.2000
									Autor: KS

rcs_id: $Id: ausgabe.c,v 5.0 2000/04/30 12:37:50 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B

*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <process.h>    /* spawnl() */
#include <sys/kernel.h> /* Send(), Receive(), Reply() */
#include <sys/types.h>  /* waitpid() */
#include <sys/wait.h>   /* waitpid() */

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#define __MAIN__
#include "header.h"
#undef __MAIN__
#include "abimport.h"
#include "proto.h"

int ausgabe(void *data, pid_t pid, void *msg, size_t msg_len)
{
	STRING_MELDUNG *meldung = (STRING_MELDUNG *)msg;
	MSG_MELDUNG *msgmsg = (MSG_MELDUNG *)msg;
	MSG_MELDUNG zuruck;
	int ecode;
	long ct; /* Fr ctime() */
	char *zeig;

	#ifdef DEBUG
	printf("conmuck: Meldung erhalten, Kennung = %s, Typ = %d\n",meldung->kennung,meldung->typ);
	#endif

	/* Antwortmeldung initialisieren */
	INIT_MELDUNG(&zuruck,KM_IST_OKAY);

	if (!KENNUNG_OKAY(meldung)) {
		/* Falsche Meldung !! */
		if (verbindung.sock >= 0) {
			close(verbindung.sock); /* Verbindung schliessen */
			verbindung.sock = -1;
			AddString(MSG_CLOSE,LOKAL);
		}
		
		PtAskQuestion(ABW_base,APP_NAME,F_MELDUNG,FEHLER_SCHRIFT,TASTER_SCHLIESSEN,NULL,NULL,1);
		zuruck.typ = KM_FEHLER;
		Reply(pid,&zuruck,sizeof(MELDUNG));

		waitpid(pid,&ecode,0);
		if (!WIFEXITED(ecode)) { /* Nicht normal beendet */
			sprintf(buf,F_BEENDEN,pid);
			PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		}
		prozessdaten.empfangs_pid = -1;
		prozessdaten.connect_pid = -1;
		prozessdaten.ipid = NULL;

		do_disconnect();

		return 0; /* Funktion "loeschen" */
	}

	/* Richtige Meldung */
	switch(meldung->typ) {
		case KM_FEHLER:
			/* In dem Prozess ein Fehler aufgetreten */
			switch(msgmsg->val) {
				case IV_F_CONNECT:
					sprintf(buf,F_CONNECT,strerror(msgmsg->v_errno));
					break;
				case IV_F_READ:
					sprintf(buf,F_READ,strerror(msgmsg->v_errno));
					break;
				default:
					sprintf(buf,F_MSGID);
					break;
			}
			PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_SCHLIESSEN,NULL,NULL,1);
			strcat(buf,MSG_F_ENDE);
			AddString(buf,LOKAL);

			/* Auf das Beenden des Prozesses warten */
			Reply(pid,&zuruck,sizeof(MELDUNG)); /* Antworten */
			waitpid(pid,&ecode,0);
			if (!WIFEXITED(ecode)) { /* Nicht normal beendet */
				sprintf(buf,F_BEENDEN,pid);
				PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
			}
			prozessdaten.empfangs_pid = -1;
			prozessdaten.connect_pid = -1;
			prozessdaten.ipid = NULL;

			/* Verbindung schliessen */
			if (verbindung.sock >= 0) {
				close(verbindung.sock);
				verbindung.sock = -1;
				AddString(MSG_CLOSE,LOKAL);
			}

			do_disconnect();

			return 0; /* Funktion "loeschen" */

		case KM_TEST:
			/* Nur KM_IST_OKAY antworten */
			Reply(pid,&zuruck,sizeof(MELDUNG));
			break;

		case KM_CLOSESOCK:
			/* Die Verbindung wurde beendet */
			close(verbindung.sock);
			verbindung.sock = -1;
			AddString(MSG_CLOSE,LOKAL);

			/* Antworten */			
			Reply(pid,&zuruck,sizeof(MELDUNG));
			/* Auf das Beenden des Prozesses warten */
			waitpid(pid,&ecode,0);
			if (!WIFEXITED(ecode)) { /* Nicht normal beendet */
				sprintf(buf,F_BEENDEN,pid);
				PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
			}
			prozessdaten.empfangs_pid = -1;
			prozessdaten.connect_pid = -1;
			prozessdaten.ipid = NULL;
			
			/* Logdatei schlieen */
			if (verbindung.fpLog) {
				fclose(verbindung.fpLog);
				verbindung.fpLog = NULL;
			}

			do_disconnect();

			return 0; /* Funktion "loeschen" */

		case KM_OPENSOCK:
			/* Neue Verbindung geffnet */
			sprintf(buf,MSG_OPEN,msgmsg->string);
			AddString(buf,LOKAL);

			/* Antworten */			
			Reply(pid,&zuruck,sizeof(MELDUNG));
			/* Auf das Beenden des Verbindungsprozesses warten */
			waitpid(pid,&ecode,0);
			if (!WIFEXITED(ecode)) { /* Nicht normal beendet */
				sprintf(buf,F_BEENDEN,pid);
				PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
			}
			prozessdaten.connect_pid = -1;
			prozessdaten.ipid = NULL;

			/* Empfangsprozess starten */
			if ((prozessdaten.empfangs_pid = spawnl(P_NOWAIT,prozessdaten.empfangs_pfad,EMPFANGS_FUNK,NULL)) == -1) {
				sprintf(buf,F_PROGAUFRUF,prozessdaten.empfangs_pfad);
				PtAskQuestion(ABW_open_dlg,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_SCHLIESSEN,NULL,NULL,1);
				close(verbindung.sock); /* Verbindung wieder schliessen */
				verbindung.sock = -1;
				prozessdaten.empfangs_pid = -1;

				return 0; /* Funktion "lschen" */
			}

			zuruck.typ = KM_OPENSOCK;
			zuruck.val = verbindung.sock;
			Send(prozessdaten.empfangs_pid,&zuruck,&zuruck,sizeof(MSG_MELDUNG),sizeof(MELDUNG));
			if (!KENNUNG_OKAY(&zuruck)) {
				PtAskQuestion(ABW_open_dlg,APP_NAME,F_MELDUNG,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
				close(verbindung.sock); /* Verbindung wieder schlieen */
				verbindung.sock = -1;
			}
			else if (zuruck.typ == KM_FEHLER) {
				PtAskQuestion(ABW_open_dlg,APP_NAME,F_SPEICHER,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
				close(verbindung.sock); /* Verbindung wieder schlieen */
				verbindung.sock = -1;
			}
			if (verbindung.sock < 0) { /* Fehler (s.o.) */
				/* Auf das Beenden des Prozesses warten */
				waitpid(pid,&ecode,0);
				if (!WIFEXITED(ecode)) { /* Nicht normal beendet */
					sprintf(buf,F_BEENDEN,pid);
					PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
				}
				prozessdaten.empfangs_pid = -1;

				return 0; /* Funktion "lschen" */
			}

			/* Verbindung hergestellt! */

			/* Die ausgabe() - Funktion als Eventhander fr alle Meldungen des 
			   Empfangsprozesses */
			prozessdaten.ipid = PtAppAddInput(NULL,prozessdaten.empfangs_pid,ausgabe,NULL);

			zeig = msgmsg->string+strlen(msgmsg->string)+1;

			/* Aktuelles Datum als ersten Eintrag in die Logdatei schreiben */
			ct = time(NULL);
			log_command("\n");
			log_command(ctime(&ct));

			/* Einloggen... */
			sprintf(buf,COMMAND_LOGIN,zeig,zeig+strlen(zeig)+1);
			do_command(buf,DC_NICHTS);

			/* Aktuelle Funktion "lschen" (jetzt kommt die fr die Empfangsfunktion) */
			return 0;

		case KM_STRING:
			/* Es wurde etwas gesendet */
			Reply(pid,&zuruck,sizeof(MELDUNG)); /* Antworten */

			log_command(meldung->string);
			qnxtophoton(buf,meldung->string);
			AddString(buf,NORMAL);
			break;

		case KM_MELDUNG:
			/* Statusmeldung */
			Reply(pid,&zuruck,sizeof(MELDUNG)); /* Antworten */
			switch(msgmsg->val) { /* Welche Meldung ? */
				case IV_MSG_OPEN:
					sprintf(buf,MSG_OPEN,msgmsg->string);
					break;
				case IV_MSG_CONNECT:
					sprintf(buf,MSG_CONNECT,msgmsg->string);
					break;
				default:
					sprintf(buf,F_MSGID);
					break;
			}
			AddString(buf,LOKAL);
			break;
	}

	return Pt_CONTINUE;
}

/* Add a string to the display widget */
void AddString(char *string,unsigned char flags)
{
	PtMultiTextAttributes_t attrib;

	PtMultiTextCreateAttributes(&attrib); /* Initialisieren */
	switch(flags & SCHRIFTFLAG) {
		case NORMAL:
			attrib.font = konfigdaten.normalschrift;
			break;
		case KOMMANDO:
			attrib.font = konfigdaten.eingschrift;
			break;
		case LOKAL:
		default:
			attrib.font = konfigdaten.msgschrift;
			break;
	}

	PtMultiTextModifyText(ABW_output,0,0,-1,string,strlen(string),&attrib,Pt_MT_FONT);
	
	return;
}

void log_command(char *text)
{
	if (verbindung.fpLog) {
		fputs(text,verbindung.fpLog);
	}
	return;
}

void qnxtophoton(char *ziel,char *quelle)
{
	/* Alle '\r's ignorieren sowie Umlaute etc. durch die Photon-Zeichen ersetzen */
	while (*quelle != '\0') {
		switch(*quelle) {
			case '\r':
				ziel--; /* Ignorieren */
				break;
			case 0x84: /* '' */
				*ziel = 0xC3;
				ziel++;
				*ziel = 0xA4;
				break;
			case 0x94: /*  */
				*ziel = 0xC3;
				ziel++;
				*ziel = 0xB6;
				break;
			case 0x81: /*  */
				*ziel = 0xC3;
				ziel++;
				*ziel = 0xBC;
				break;
			case 0x8E: /* '' */
				*ziel = 0xC3;
				ziel++;
				*ziel = 0x84;
				break;
			case 0x99: /*  */
				*ziel = 0xC3;
				ziel++;
				*ziel = 0x96;
				break;
			case 0x9A: /*  */
				*ziel = 0xC3;
				ziel++;
				*ziel = 0x9C;
				break;
			case 0xE1: /*  */
				*ziel = 0xC3;
				ziel++;
				*ziel = 0x9F;
				break;
			default:
				*ziel = *quelle;
				break;
		}
		quelle++;
		ziel++;
	}

	*ziel = '\0';

	return;
}

void do_disconnect(void)
{
	PtArg_t args[1];
	char *zeig = APP_NAME;

	/* Default-Titel setzen */
	PtSetArg(&args[0],Pt_ARG_WINDOW_TITLE,zeig,0);
	PtSetResources(ABW_base,1,args);

	/* Meneintrge verndern */
	/* Man kann wieder Verbindungen ffnen */
	ApModifyItemState(&verbindungs_menu,AB_ITEM_NORMAL,ABN_idm_open,NULL);
	/* Man kann keine Verbindung mehr schlieen und keine Dateien mehr senden */
	ApModifyItemState(&verbindungs_menu,AB_ITEM_DIM,ABN_idm_close,ABN_idm_sendfile,NULL);

	/* Editierfeld und Senden-Taster sperren */
	PtSetArg(&args[0],Pt_ARG_FLAGS,Pt_BLOCKED | Pt_GHOST,Pt_BLOCKED | Pt_GHOST);
	PtSetResources(ABW_command,1,args);
	PtSetResources(ABW_ok,1,args);

	return;
}

void do_connect(char *muckname)
{
	PtArg_t args[1];

	/* Titel setzen */
	sprintf(buf,"%s - %s",APP_NAME,muckname);
	PtSetArg(&args[0],Pt_ARG_WINDOW_TITLE,buf,0);
	PtSetResources(ABW_base,1,args);

	/* Meneintrge richten */
	/* Man kann keine Verbindungen mehr ffnen */
	ApModifyItemState(&verbindungs_menu,AB_ITEM_DIM,ABN_idm_open,NULL);
	/* Man kann die Verbindung schlieen und Dateien senden */
	ApModifyItemState(&verbindungs_menu,AB_ITEM_NORMAL,ABN_idm_close,ABN_idm_sendfile,NULL);

	/* Editierfeld und Senden-Taster freigeben */
	PtSetArg(&args[0],Pt_ARG_FLAGS,0,Pt_BLOCKED | Pt_GHOST);
	PtSetResources(ABW_command,1,args);
	PtSetResources(ABW_ok,1,args);

	return;
}
