/* Funktionen fr die Konfigurationsdatei

									Datei: cfgdatei.c
									Datum: 30.12.1996
									Rev. : 30.04.1997
									Autor: KS

rcs_id: $Id: cfgdatei.c,v 5.0 2000/04/30 12:35:15 klaus Exp klaus $

*/

#include <stdio.h>     /* ...printf() */
#include <stdlib.h>
#include <string.h>    /* strcpy() */
#include <sys/types.h> /* fchmod() */
#include <sys/stat.h>  /* fchmod() */

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#define __INIT__
#include "msg.h"
#undef __INIT__
#include "config.h" /* Aussehen der Konfigurationsdatei */
#include "header.h"

#include "abimport.h"
#include "proto.h"


/* Die Konfigurationsdateibibliothek einbinden */
#include "../cfgdatei/cfgdatei.c"

int read_configfile(void)
{
	FILE *fp; /* Dateizeiger */
	INHALT *muckinhalt;       /* Zum Auslesen der Mucks */
	EINTRAEGE *muckeintraege; /*  "      "     "    "   */
	ALLE_ABSCHNITTE *abzwzeig,*abzw2zeig; /* " */
	int ind,eintrind; /* Indizes */
	KONFIGSTRUKT; /* Konfigurationsstruktur */

	/* Konfigurationsdatei ffnen */
	if ((fp = fopen(konfigdaten.cfgdateiname,"rb")) == NULL) { /* Konfigurationsdatei oeffnen */

		/* Konfigurationsdatei konnte nicht geffnet werden */
		/* Sprache auswhlen lassen */
		verbindung.sock = 0;
		ApCreateModule(ABM_cfgdatei_dlg,NULL,NULL);
		ind = PtModalStart();
		while(verbindung.sock == 0) {
			PtProcessEvent();
		}
		PtModalEnd(ind);

		/* Versuchen, die interne Konfigurationsdatei zu benutzen und eine neue Datei zu erstellen */
		if ((fp = make_sample_cfgdatei(konfigdaten.cfgdateiname)) == NULL) { /* Neu erstellen */
			sprintf(buf,F_CREATE,konfigdaten.cfgdateiname,strerror(errno));
			PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
			return Pt_CONTINUE;
		}
	}

	/* Standartdaten lesen ------------------------------------------------ */
	cfgdateilesen(fp,konfigdaten.cfgdateiname,inhalt);
	rewind(fp); /* Zum Anfang zurueckgehen */

	KONFIG_ZUWEISUNG(konfigdaten); /* Die richtigen Werte zuweisen */

	/* Sprache setzen ----------------------------------------------------- */
	if (konfigdaten.sprache) {
		ApSetTranslation(konfigdaten.sprache);
	}

	/* Die Mucks einlesen ------------------------------------------------- */
	abzwzeig = abzw2zeig = inhalt[KONFIG_ABSCHNITTSANZ].abschnitt.alle_abschnitte;
	for(mucks.muckanz=0;abzwzeig;abzwzeig = abzwzeig->next,mucks.muckanz++); /* Anzahl Mucks */

	if (mucks.muckanz == 0) { /* Keine Mucks - gleich zurueck */
		fclose(fp);
		return Pt_CONTINUE;
	}

	/* Speicherplatz zum Einlesen allokieren */
	if ((mucks.muckdaten = (MUCKDATEN *)malloc(mucks.muckanz*sizeof(MUCKDATEN))) == NULL) {
		PtAskQuestion(ABW_base,APP_NAME,F_SPEICHER,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		fclose(fp);
		return Pt_CONTINUE;
	}

	if ((muckinhalt = (INHALT *)malloc((mucks.muckanz+1)*sizeof(INHALT))) == NULL) {
		PtAskQuestion(ABW_base,APP_NAME,F_SPEICHER,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		fclose(fp);
		return Pt_CONTINUE;
	}
	if ((muckeintraege = (EINTRAEGE *)malloc(mucks.muckanz*((KONFIG_EINTRAGSANZ+1)*sizeof(EINTRAEGE)))) == NULL) {
		PtAskQuestion(ABW_base,APP_NAME,F_SPEICHER,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		fclose(fp);
		return Pt_CONTINUE;
	}

	abzwzeig = abzw2zeig;
	for(ind=0;ind < mucks.muckanz;ind ++) {
		eintrind = ind*(KONFIG_EINTRAGSANZ+1);
		mucks.muckdaten[ind].name = muckinhalt[ind].abschnitt.abschnitt = abzwzeig->abschnitt;
		abzw2zeig = abzwzeig;
		abzwzeig = abzwzeig->next;
		free(abzw2zeig); /* Struktur freigeben */
		muckinhalt[ind].eintraege = (muckeintraege+eintrind);
		muckinhalt[ind].optionen = GROSSKLEINEGAL;

		KONFIG_MUCKEINTRZUWEISUNG(muckeintraege,eintrind,mucks,ind); /* Eintraege init. */
	}
	muckinhalt[ind].eintraege = NULL;
	muckinhalt[ind].optionen  = 0;

	#ifdef DEBUG
	ind = fread(buf,sizeof(char),BUFLEN-1,fp);
	*(buf+ind) = '\0';
	printf("Gelesen: %d Bytes\n",ind);
	printf(buf);
	rewind(fp);
	#endif

	cfgdateilesen(fp,konfigdaten.cfgdateiname,muckinhalt); /* Daten auslesen */
	fclose(fp); /* Datei schliessen */

	/* Speicherplatz, der zum Einlesen gebraucht wurde, wieder freigeben */
	free(muckeintraege);
	free(muckinhalt);

	#ifdef DEBUG
	for(ind=0;ind<mucks.muckanz;ind++) {
		printf("Muck %d: %s\n",ind,mucks.muckdaten[ind].name);
	}
	#endif

	return Pt_CONTINUE;
}

FILE *make_sample_cfgdatei(char *dateiname)
{
	char *sample_cfgfile = \
		"# Configuration file for KonnMuck\n" \
		"#\n" \
		"# Here, you can configure the KonnMuck application and set a list of\n" \
		"# MUDs.\n" \
		"# Lines which start with a sharp sign (#) (as this one!) are comments.\n" \
		"# You can set values with\n" \
		"# KEYWORD = VALUE ;\n" \
		"# where KEYWORD is the corresponding keyword and VALUE is your value.\n" \
		"# Case is not recognized in the KEYWORDs. Strings are to be enclosed\n" \
		"# with double quotes (\"). However, strings are case sensitive.\n" \
		"# Please do not forget the terminating semicolon!\n" \
		"\n" \
		"# Look at this sample configuration file.\n" \
		"\n" \
		"# Language\n" \
		"%sLanguage = \"%s\"; # Use %s\n" \
		"\n" \
		"# Size and position of the application window\n" \
		"# X = 0; # We don't care about the position, so we comment it out.\n" \
		"# Y = 0; # If you do, just remove the comment '#' and set it to a value unequal zero.\n" \
		"Width  = 628;\n" \
		"Height = 418;\n" \
		"\n" \
		"# Fonts used in the Output window\n" \
		"Outputfont  = \"tech12\";  # Font for 'normal' output\n" \
		"Inputfont   = \"helv12i\"; # Font for commands\n" \
		"Messagefont = \"time12i\"; # Font for information messages\n" \
		"\n" \
		"# The command used to log in\n" \
		"ConnectString = \"co %s %s\";\n" \
		"\n" \
		"# Now, we define some MUDs\n" \
		"# Definition of MUDs is done in the following way:\n" \
		"#\n" \
		"# The Name of the MUD is given in brackets; that starts the definition\n" \
		"# of the MUD data.\n" \
		"[ArKania]\n" \
		"# At first, we define the server to be used\n" \
		"Host = \"ds3.etech.fh-hamburg.de\";\n" \
		"Port = 5026;\n" \
		"# Our Character data is following\n" \
		"# If you have a character at a MUD, just put in your character name\n" \
		"# and password here, and KonnMuck will automatically connect to your\n" \
		"# character.\n" \
		"Character = \"Guest\";\n" \
		"Password  = \"guest\";\n" \
		"# If we like to log our sessions, let's define our logfile here\n" \
		"# If you like your sessions to be logged, just remove the sharp sign\n" \
		"# before the definition below and select a valid filename.\n" \
		"#Logfile   = \"/home/myname/mylogfile\";\n" \
		"\n" \
		"# Now, we're complete. You can define as many MUDs as you like.\n" \
		"\n" \
		"\n" \
		"# Let's try another MUD\n" \
		"[HoloMuck]\n" \
		"\n" \
		"Host = \"holo.rodents.montreal.qc.ca\";\n" \
		"Port = 5757;\n" \
		"Character = \"Guest\";\n" \
		"Password  = \"guest\";\n" \
		"# No Logfile this time\n" \
		"# Just add a Logfile statement if you wish to have one\n" \
		"\n" \
		"\n" \
		"[Aiden] # Just another MUD\n" \
		"\n" \
		"Host = \"gentle.ydea.com\";\n" \
		"Port = 1660;\n" \
		"Character = \"Guest\";\n" \
		"Password  = \"guest\";\n" \
		"Logfile   = \"/home/myname/anotherdirectory/mylogfile\";\n" \
		"\n" \
		"# Have fun!\n" \
		"\n" ;

	FILE *fp;
	char *zeig;

	/* Datei erstellen */
	if ((fp = fopen(dateiname,"wb+")) == NULL) {
		return NULL;
	}
	/* Rechte auf -rw------- */
	fchmod(fileno(fp),S_IRUSR | S_IWUSR);

	/* Pointer setzen */
	for(zeig=buf;*zeig != '\0';zeig++);
	zeig++;

	/* Konfigurationsdatei erstellen */
	fprintf(fp,sample_cfgfile,(!(*buf)) ? "#" : "",buf,zeig);
	rewind(fp);

	return fp;
}

int cfgdlg_done(PtWidget_t *widget,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	verbindung.sock = -1;
	return Pt_CONTINUE;
}

int item_sel(PtWidget_t *widget,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	PtListCallback_t *selinfo = cbinfo->cbdata;

	if (cbinfo->reason_subtype != Pt_LIST_SELECTION_FINAL) {
		/* Wenn nicht ein Eintrag angeklickt, nichts machen */
		return Pt_CONTINUE;
	}

	/* Ausfhren */
	do_cfgdatei_setup(widget,selinfo->item_pos,selinfo->item);

	/* Das war's */
	return Pt_CONTINUE;
}

void do_cfgdatei_setup(PtWidget_t *widget,int item_pos,char *item)
{
	PtArg_t args[1];
	char *zeig,*zeig2;
	int ind;

	/* bersetzungskrzel holen */
	PtSetArg(&args[0],Pt_ARG_USER_DATA,&zeig,0);
	PtGetResources(widget,1,args);

	/* Zum richtigen gehen */
	for(zeig2=zeig,ind=0;ind < item_pos-1;ind++) {
		for(;*zeig2 != ';' && *zeig2 != '\0';zeig2++);
		if (*zeig2 != '\0') zeig2++;
	}

	/* Und kopieren */
	strcpy(buf,zeig2);
	/* Zum Ende gehen */
	for(zeig=buf;*zeig != ';' && *zeig != '\0';zeig++);
	/* Anschlieen */
	*zeig = '\0';
	zeig++;

	/* Der Name */
	strcpy(zeig,item);

	/* Das war's */
	return;
}

int cfgdatei_dlg_setup(PtWidget_t *link_instance,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	unsigned short *index = (unsigned short *)buf;
	PtArg_t args[1];
	char **items;
	int len;

	/* Ersten Eintrag markieren */
	index[0] = 1;
	index[1] = 0;
	PtSetArg(&args[0],Pt_ARG_SELECTION_INDEXES,index,1);
	PtSetResources(ABW_languages,1,args);

	/* Wert des ersten Eintrags holen */
	PtSetArg(&args[0],Pt_ARG_ITEMS,&items,&len);
	PtGetResources(ABW_languages,1,args);

	/* Und richtig setzen */
	do_cfgdatei_setup(ABW_languages,1,items[0]);

	return Pt_CONTINUE;
}
