/* Schieen einer Verbindung

										Datei: close_con.c
										Datum: 01.09.1996
										Rev. : 26.04.1997
										Autor: KS

rcs_id: $Id: close_con.c,v 4.21 1997/04/27 12:13:29 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B

*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/kernel.h> /* Send() */
#include <sys/socket.h> /* shutdown() */
#include <sys/wait.h>   /* waitpid() */

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"

int close_con( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{

	if (verbindung.sock < 0) { /* Wenn keine Verbindung da ist */
		return Pt_CONTINUE;
	}

	/* Verbindung beenden */	
	shutdown(verbindung.sock,2);
	verbindung.sock = -1;
	
	/* Logdatei schlieen */
	if (verbindung.fpLog) {
		fclose(verbindung.fpLog);
		verbindung.fpLog = NULL;
	}

	/* Alle weiteren Prozesse runterfahren */
	prozesse_runterfahren();

	/* "Verbindung beendet" - Meldung ausgeben */
	AddString(MSG_CLOSE,LOKAL);

	do_disconnect();

	return( Pt_CONTINUE );
}

void prozesse_runterfahren(void)
{
	int ecode,retmsg;
	MELDUNG meldung;
	pid_t pid;

	if (prozessdaten.empfangs_pid != -1) {
		/* Wenn Empfangsprozess da, Beenden-Meldung davon verarbeiten */
		pid = prozessdaten.empfangs_pid;
		ecode = KM_CLOSESOCK;
		retmsg = KM_IST_OKAY;
	}
	else {
		/* Der Verbindungsprozess ist da */
		pid = prozessdaten.connect_pid;
		ecode = KM_TEST;
		retmsg = KM_FEHLER;
	}

	Receive(pid,&meldung,sizeof(MELDUNG));
	if ((!KENNUNG_OKAY(&meldung)) || (meldung.typ != ecode)) {
		PtAskQuestion(ABW_base,APP_NAME,F_MELDUNG,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
	}
	meldung.typ = retmsg;
	Reply(pid,&meldung,sizeof(MELDUNG));

	/* Warten, bis das Programm beendet ist */
	waitpid(pid,&ecode,0);
	if (!WIFEXITED(ecode)) { /* Nicht normal beendet */
		sprintf(buf,F_BEENDEN,pid);
		PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
	}
	PtAppRemoveInput(NULL,prozessdaten.ipid); /* Ausgabefunktion "loeschen" */
	prozessdaten.empfangs_pid = -1;
	prozessdaten.connect_pid = -1;
	prozessdaten.ipid = NULL;

	return;
}
