/* Inhalt & Aussehen der Konfigurationsdatei von KonnMuck

										Datei: config.h
										Datum: 04.10.1996
										Rev. : 30.12.1996
										Rev.2: 30.04.2000
										Autor: KS
*/

#ifndef __CONFIG_H_INCLUDED__
#define __CONFIG_H_INCLUDED__


#define KONFIGDATEI ".konnmuck.cfg"


#ifndef __HEADER_H_INCLUDED__ /* Nicht in header.h */
#include "msg.h" /* Namen der Eintraege */

/* Standartdaten-Konfiguration -------------------------------------------- */

#define KONFIGSTRUKT /* Konfigurationsstruktur */ \
EINTRAEGE def_konfig[] = { \
	{ K_X,             NUMBER, { NULL }, NULL }, \
	{ K_Y,             NUMBER, { NULL }, NULL }, \
	{ K_HOEHE,         NUMBER, { NULL }, NULL }, \
	{ K_BREITE,        NUMBER, { NULL }, NULL }, \
	{ K_NORMALSCHRIFT, STRING, { "time14" }, NULL }, \
	{ K_EINGSCHRIFT,   STRING, { "time14" }, NULL }, \
	{ K_MSGSCHRIFT,    STRING, { "time14" }, NULL }, \
	{ K_FEHLERSCHRIFT, STRING, { "time14" }, NULL }, \
	{ K_SPRACHE,       STRING, { NULL }, NULL } , \
	{ K_CONNECT,       STRING, { DEFAULT_LOGIN_CMD }, NULL }, \
	{ NULL,            0,      { NULL }, NULL } }; \
\
INHALT inhalt[] = { \
	{ { NULL }, GROSSKLEINEGAL, NULL }, \
	{ { NULL }, GROSSKLEINEGAL | MEHR | ABSCHNITTE, NULL } }; \
\
inhalt[0].eintraege = def_konfig; \
def_konfig[0].werte.val = -1  /* Kein Semikolon */

#define KONFIG_ABSCHNITTSANZ 1 /* Anzahl der Abschnitte fuer die Normaldateb */

#define KONFIG_ZUWEISUNG(__konfigdaten) /* Zuweisung der Werte */ \
	__konfigdaten.area.pos.x    = __konfigdaten.cfgarea.pos.x  = def_konfig[0].werte.val; \
	__konfigdaten.area.pos.y    = __konfigdaten.cfgarea.pos.y  = def_konfig[1].werte.val; \
	__konfigdaten.area.size.h   = __konfigdaten.cfgarea.size.h = def_konfig[2].werte.val; \
	__konfigdaten.area.size.w   = __konfigdaten.cfgarea.size.w = def_konfig[3].werte.val; \
	__konfigdaten.normalschrift = def_konfig[4].werte.string; \
	__konfigdaten.eingschrift   = def_konfig[5].werte.string; \
	__konfigdaten.msgschrift    = def_konfig[6].werte.string; \
	__konfigdaten.fehlerschrift = def_konfig[7].werte.string; \
	__konfigdaten.sprache       = def_konfig[8].werte.string; \
	__konfigdaten.logincmd      = def_konfig[9].werte.string; \


/* Muck - Konfiguration --------------------------------------------------- */

#define KONFIG_MUCKEINTRZUWEISUNG(__eintr,__eind,__mucks,__ind) /* Zuweisung der Werte bei den Muckeintraegen */ \
	__eintr[__eind].bezeichner = K_HOST; \
	__eintr[__eind].typ = STRING_PTR; \
	__eintr[__eind].werte.string_ptr = &(__mucks.muckdaten[__ind].host); \
	__mucks.muckdaten[__ind].host = NULL; \
\
	__eind++; \
	__eintr[__eind].bezeichner = K_PORT; \
	__eintr[__eind].typ = INT_PTR; \
	__eintr[__eind].werte.int_ptr = &(__mucks.muckdaten[__ind].port); \
	__mucks.muckdaten[__ind].port = 0; \
 \
	__eind++; \
	__eintr[__eind].bezeichner = K_CHARAKTER; \
	__eintr[__eind].typ = STRING_PTR; \
	__eintr[__eind].werte.string_ptr = &(__mucks.muckdaten[__ind].charaktername); \
	__mucks.muckdaten[__ind].charaktername = NULL; \
\
	__eind++; \
	__eintr[__eind].bezeichner = K_PASSWORT; \ 
	__eintr[__eind].typ = STRING_PTR; \
	__eintr[__eind].werte.string_ptr = &(__mucks.muckdaten[__ind].passwort); \
	__mucks.muckdaten[__ind].passwort = NULL; \
\
	__eind++; \
	__eintr[__eind].bezeichner = K_LOGFILE; \ 
	__eintr[__eind].typ = STRING_PTR; \
	__eintr[__eind].werte.string_ptr = &(__mucks.muckdaten[__ind].logfile); \
	__mucks.muckdaten[__ind].logfile = NULL; \
\
	__eind++; /* NULL - markiert das Ende */ \
	__eintr[__eind].bezeichner = __eintr[__eind].werte.string = NULL; \
	__eintr[__eind].typ = 0; \


/* Freigeben des durch die Muckkonfiguration benutzten Speicherplatzes ---- */

#define FREEMUCKLIST(__mucklist) /* Freigeben aller Puffer der Muckliste */ \
	while(__mucklist.muckanz > 0) { \
		__mucklist.muckanz--; \
		if (__mucklist.muckdaten[__mucklist.muckanz].host) /* Host */ \
			free(__mucklist.muckdaten[__mucklist.muckanz].host); \
		if (__mucklist.muckdaten[__mucklist.muckanz].charaktername) /* Charaktername */ \
			free(__mucklist.muckdaten[__mucklist.muckanz].charaktername); \
		if (__mucklist.muckdaten[__mucklist.muckanz].passwort) /* Passwort des Charakters */ \
			free(__mucklist.muckdaten[__mucklist.muckanz].passwort); \
		if (__mucklist.muckdaten[__mucklist.muckanz].logfile) /* Name der Logdatei */ \
			free(__mucklist.muckdaten[__mucklist.muckanz].logfile); \
	} \
	free(__mucklist.muckdaten); \

#endif /* !__HEADER_H_INCLUDED__ */


#endif /* __CONFIG_H_INCLUDED__ */


#if ((defined __HEADER_H_INCLUDED__) && (defined __HEADER_H_DA__)) /* Nur in header.h */
/* Typedefs */
typedef struct { /* Konfigurationsparameter */
	char *cfgdateiname; /* Name der Konfigurationsdatei (bleibt gleich) */
	PhArea_t area; /* Groesse des Hauptfensters */
	PhArea_t cfgarea; /* In der CFG-Datei eingestellte Gre des Hauptfensters */
	char *normalschrift;
	char *eingschrift;
	char *msgschrift;
	char *fehlerschrift;
	char *sprache;
	char *logincmd;
	/* Gehrt hier eigentlich nicht hin, aber wo denn sonst? */
	char *datendateiname;
	int letzter_weihnachtsgruss;
} KONFIG;


#define KONFIG_EINTRAGSANZ 8 /* Anzahl Eintraege pro Abschnitt */

typedef struct {
	char *name; /* Name des Mucks */
	char *host; /* Adresse */
	int port; /* Port */

	char *charaktername; /* Charaktername */
	char *passwort;      /* Passwort */

	char *logfile;       /* Name der Logdatei */
} MUCKDATEN;

typedef struct {
	MUCKDATEN *muckdaten;
	int muckanz;
} MUCKS;
#endif /* __HEADER_H_INCLUDED__ */
