/* Prozess, der die Verbindung ffnet, fr KonnMuck

										Datei: connect.c
										Datum: 17.10.1996
										Rev. : 03.01.1997
										Autor: KS

rcs_id: $Id: connect.c,v 4.0 1997/01/04 12:18:25 klaus Exp klaus $

*/

//#define DEBUG


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/kernel.h> /* Send() */
/* TCP/IP */
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define __CONNECT_PROC__
#include "header.h"


/* Konstanten */
#define FALSCHE_KENNUNG "Fehler!!"
#define FALSCHE_KENNUNG_LEN 9


void main(void)
{
	MELDUNG meldung;
	STRING_MELDUNG *strmsg;
	MSG_MELDUNG *msgmsg;
	CONNECT_MELDUNG *conmsg;
	char *hostname,*charakter,*passwort;
	int len;
	struct sockaddr_in server;
	struct hostent *hp;
	int sock;
	pid_t pid;

	/* Erst mal sehen, ob auch richtig aufgerufen */
	pid = Receive(0,&meldung,sizeof(MELDUNG));

	if (!KENNUNG_OKAY(&meldung)) {
		/* Falsche Kennung !! */
		Reply(pid,FALSCHE_KENNUNG,FALSCHE_KENNUNG_LEN);
		exit(-1);
	}

	/* War richtig! */
	
	/* Nur ausprobieren, ob das Programm verfgbar ist? */
	if (meldung.typ == KM_TEST) {
		meldung.typ = KM_IST_OKAY;
		Reply(pid,&meldung,sizeof(MELDUNG));
		exit(0);
	}
	
	/* Progamm benutzen */

	/* Puffer allokieren */
	if ((conmsg = (CONNECT_MELDUNG *)malloc(sizeof(CONNECT_MELDUNG)+BUFLEN)) == NULL) {
		meldung.typ = KM_FEHLER;
		Reply(pid,&meldung,sizeof(MELDUNG));
		exit(-2);
	}
	strmsg = (STRING_MELDUNG *)conmsg;
	msgmsg = (MSG_MELDUNG *)conmsg;

	/* Antworten */
	meldung.typ = KM_IST_OKAY;
	Reply(pid,&meldung,sizeof(MELDUNG));
	
	Receive(pid,conmsg,sizeof(CONNECT_MELDUNG)+BUFLEN);
	if (!KENNUNG_OKAY(conmsg)) {
		Reply(pid,FALSCHE_KENNUNG,FALSCHE_KENNUNG_LEN);
		free(conmsg);
		exit(-1);
	}
	conmsg->typ = KM_IST_OKAY;
	Reply(pid,conmsg,sizeof(MELDUNG));

	/* Werte setzen */
	sock = conmsg->sock;
	memset((char *)&server,0,sizeof(server));
	memcpy((char *)&server.sin_addr,conmsg->string+conmsg->hostaddroffset,conmsg->h_length);
	server.sin_family = conmsg->h_addrtype;
	server.sin_port = htons((u_short)conmsg->port);
	/* Hostname */
	hostname = (char *)conmsg+sizeof(CONNECT_MELDUNG)+BUFLEN/2; /* In den zweiten Teil von buf */
	strcpy(hostname,conmsg->string+conmsg->hostnamenoffset);
	/* Charaktername */
	charakter = hostname+strlen(hostname)+1;
	strcpy(charakter,conmsg->string+conmsg->namenoffset);
	/* Charakterpasswort */
	passwort = charakter+strlen(charakter)+1;
	strcpy(passwort,conmsg->string+conmsg->passwdoffset);

	#ifdef DEBUG
	printf("connect: vor connect(), hostname = %s,\nCharakter = %s, Passwort = %s\n",hostname,charakter,passwort);
	#endif

	/* Statusmeldung schicken */
	msgmsg->typ = KM_MELDUNG;
	msgmsg->val = IV_MSG_CONNECT;
	strcpy(msgmsg->string,(char *)inet_ntoa(server.sin_addr.s_addr));

	Send(pid,msgmsg,&meldung,sizeof(MSG_MELDUNG)+strlen(msgmsg->string)+1,sizeof(MELDUNG));
	if (!OKAY(&meldung)) {
		free(conmsg);
		close(sock);
		exit(-1);
	}

	/* Verbindung herstellen */
	if ((len = connect(sock,(struct sockaddr *)&server,sizeof(server))) < 0) {
		#ifdef DEBUG
		printf("connect() failed: %s\n",strerror(errno));
		#endif
		strmsg->typ = KM_FEHLER;
		#ifdef DEBUG
		printf("msgmsg->typ = %d, msgmsg->kennung = %s\n",msgmsg->typ, msgmsg->kennung);
		#endif
		msgmsg->val = IV_F_CONNECT;
		msgmsg->v_errno = errno;
		Send(pid,msgmsg,&meldung,sizeof(MSG_MELDUNG),sizeof(MELDUNG));
		free(conmsg);
		close(sock);
		exit(-2);
	}

	/* Okay? Es knnte ja unterbrochen worden sein */
	INIT_MELDUNG(&meldung,KM_TEST);
	Send(pid,&meldung,&meldung,sizeof(MELDUNG),sizeof(MELDUNG));
	if (!OKAY(&meldung)) { /* Fehler */
		free(conmsg);
		exit(-1);
	}

	/* Verbindung geglckt !! */

	#ifdef DEBUG
	printf("conmuck: Verbindung geoeffnet, socket = %d\nRckgabewert: %d\n",sock,len);
	#endif

	/* Statusmeldung: Alles hat geklappt! */
	msgmsg->typ = KM_OPENSOCK;
	msgmsg->val = IV_MSG_OPEN;
	strcpy(msgmsg->string,hostname);
	len = strlen(msgmsg->string)+1;

	#ifdef DEBUG
	printf("Charakter = \"%s\", Passwort = \"%s\"\n",charakter,passwort);
	#endif

	/* Charakternamen und Passwort bergeben */
	strcpy(msgmsg->string+len,charakter);
	len += (strlen(msgmsg->string+len)+1);
	strcpy(msgmsg->string+len,passwort);
	len += (strlen(msgmsg->string+len)+1);

	/* Senden */
	Send(pid,msgmsg,&meldung,sizeof(MSG_MELDUNG)+len,sizeof(MELDUNG));

	free(conmsg);
	close(sock);
	exit(-1);
}
