/* Initialisierungsfunktion

									Datei: init.c
									Datum: 01.09.1996
									Rev. : 26.04.1997
									Rev.2: 30.04.2000
									Autor: KS

rcs_id: $Id: init.c,v 6.0 2000/04/30 12:39:34 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B
*/

//#define DEBUG

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <process.h>    /* spawnl() */
#include <pwd.h>        /* getpwnam() */
#include <sys/types.h>  /* getpwnam(), waitpid() */
#include <sys/wait.h>   /* waitpid() */
#include <sys/kernel.h> /* Send(), Receive(), Reply() */
#include <sys/psinfo.h> /* qnx_psinfo() */
#include <sys/stat.h>   /* fchmod */

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"


int init(int argc,char *argv[])
{
	char *zeig; /* Zw-Zeiger */
	struct passwd *pw; /* Fr getpwnam() -> Home-Directory */
	pid_t pid;       /* Pid zum Testen des Empfangs- und Verbindungsprozesses */
	MELDUNG meldung; /* Meldung "  "    "      "      "            "          */
	int ecode;       /* Exitcode der           "      "            "          */
	struct _psinfo psdata; /* Um den Pfad, auf dem es luft, rauszufinden */

	/* Datenbank fr Mehrsprachen-Untersttzung aufmachen */
	if ((textdb = ApOpenDBase(ABM_meldungen)) == NULL) {
		PtAskQuestion(ABW_base,APP_NAME,F_FATAL_DBASE,DEF_FEHLER_SCHRIFT,DEF_TASTER_BEENDEN,NULL,NULL,1);
		exit(-1);
	}

	/* Puffer allokieren */
	if ((buf = (unsigned char *)malloc(BUFLEN+PASSWDLEN)) == NULL) {
		PtAskQuestion(ABW_base,APP_NAME,F_SPEICHER,DEF_FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
		ApCloseDBase(textdb);
		exit(-1);
	}
	muckpasswort = buf + BUFLEN;

	/* Pfadname holen */
	qnx_psinfo(0,0,&psdata,0,0);

	/* Pfad- und Programmname des Empfangsprogramms setzen */
//	_fullpath(buf,argv[0],_MAX_PATH); /* Pfad, wo das aufgerufene Programm steht */
    strcpy(buf,psdata.un.proc.name);
	for(zeig = buf;*zeig != '\0';zeig++);
	for(;*zeig != '/' && zeig > buf;zeig--);
	if (*zeig == '/') zeig++; /* '/' berlesen */
	strcpy(zeig,EMPFANGS_FUNK); /* Programmname hinzufgen */
	prozessdaten.empfangs_pfad = strdup(buf);
	prozessdaten.empfangs_pid = -1; /* Am Anfang nicht da */

	/* Empfangsprogramm austesten und so die meisten Fehler am Anfang abfangen */
	if ((pid = spawnl(P_NOWAIT,prozessdaten.empfangs_pfad,EMPFANGS_FUNK,NULL)) == -1) {
		sprintf(buf,F_PROGAUFRUF,prozessdaten.empfangs_pfad);
		PtAskQuestion(ABW_open_dlg,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
		free(buf);
		ApCloseDBase(textdb);
		exit(-2);
	}
	INIT_MELDUNG(&meldung,KM_TEST);
	Send(pid,&meldung,&meldung,sizeof(MELDUNG),sizeof(MELDUNG));
	if (!KENNUNG_OKAY(&meldung)) {
		PtAskQuestion(ABW_open_dlg,APP_NAME,F_MELDUNG,DEF_FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
		free(buf);
		ApCloseDBase(textdb);
		exit(-3);
	}
	waitpid(pid,&ecode,0);
	if (!WIFEXITED(ecode)) {
		sprintf(buf,F_BEENDEN,pid);
		PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
		free(buf);
		ApCloseDBase(textdb);
		exit(-4);
	}
	
	/* Pfad- und Programmname des Verbindungsprogramms setzen */
    strcpy(buf,psdata.un.proc.name);
	for(zeig = buf;*zeig != '\0';zeig++);
	for(;*zeig != '/' && zeig > buf;zeig--);
	if (*zeig == '/') zeig++; /* '/' berlesen */
	strcpy(zeig,CONNECT_FUNK); /* Programmname hinzufgen */
	prozessdaten.connect_pfad = strdup(buf);
	prozessdaten.connect_pid = -1; /* Am Anfang nicht da */
	
	/* Verbindungsprogramm austesten und so die meisten Fehler am Anfang abfangen */
	if ((pid = spawnl(P_NOWAIT,prozessdaten.connect_pfad,EMPFANGS_FUNK,NULL)) == -1) {
		sprintf(buf,F_PROGAUFRUF,prozessdaten.connect_pfad);
		PtAskQuestion(ABW_open_dlg,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
		free(buf);
		ApCloseDBase(textdb);
		exit(-2);
	}
	INIT_MELDUNG(&meldung,KM_TEST);
	Send(pid,&meldung,&meldung,sizeof(MELDUNG),sizeof(MELDUNG));
	if (!KENNUNG_OKAY(&meldung)) {
		PtAskQuestion(ABW_open_dlg,APP_NAME,F_MELDUNG,DEF_FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
		free(buf);
		ApCloseDBase(textdb);
		exit(-3);
	}
	waitpid(pid,&ecode,0);
	if (!WIFEXITED(ecode)) {
		sprintf(buf,F_BEENDEN,pid);
		PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_BEENDEN,NULL,NULL,1);
		free(buf);
		ApCloseDBase(textdb);
		exit(-4);
	}


	/* Anfang = nicht verbunden */
	verbindung.sock = -1;
	verbindung.fpLog = NULL;

	/* Konfigurationsdateiname erstellen */
	pw = getpwnam(getlogin()); /* Infos ueber den Benutzer holen */
	strcpy(buf,pw->pw_dir); /* Home-Verzeichnis */
	for(zeig = buf;*zeig != '\0'; zeig++); /* Ans Ende gehen */
	*zeig = '/';
	zeig++;
	strcpy(zeig,KONFIGDATEI); /* Name der Konfigurationsdatei */
	konfigdaten.cfgdateiname = strdup(buf);
	strcpy(zeig,DATENDATEI); /* Name der Datendatei */
	konfigdaten.datendateiname = strdup(buf);

	/* Konfigurationsdatei auslesen und Werte setzen */	
	read_configfile();
	read_datafile();

	/* Fertig */
	return Pt_CONTINUE;
}

void read_datafile(void)
{
	FILE *fp;
	char *datei = konfigdaten.datendateiname;

	if ((fp = fopen(datei,"rb")) != NULL) {
		if ((filelength(fileno(fp)) == sizeof(int)) &&
			(fread(&konfigdaten.letzter_weihnachtsgruss,sizeof(int),1,fp) == 1)) {
			/* Hat geklappt */
			fclose(fp);
			return;
		}
		fchmod(fileno(fp),S_IRUSR | S_IWUSR);
		fclose(fp);
	}

	/* falsches Format oder existiert nicht -- neu anlegen */
	if ((fp = fopen(datei,"wb+")) == NULL) {
		/* Geht auch nicht! */
		sprintf(buf,F_CREATE,datei,strerror(errno));
		PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		return;
	}
	konfigdaten.letzter_weihnachtsgruss = 0;
	fwrite(&konfigdaten.letzter_weihnachtsgruss,sizeof(int),1,fp);
	fclose(fp);
	return;
}

void write_datafile(void)
{
	FILE *fp;
	char *datei = konfigdaten.datendateiname;

	if ((fp = fopen(datei,"wb")) == NULL) {
		sprintf(buf,F_CREATE,datei,strerror(errno));
		PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		return;
	}
	fwrite(&konfigdaten.letzter_weihnachtsgruss,sizeof(int),1,fp);
	fclose(fp);
	return;
}		

#ifdef DEBUG
void test_yy_exterror(char *s,char *t,char *yytext,int yyzeile,char *yycfgdatei)
{
	char *test;
	
	test = ApGetTextRes(textdb,"@f_yy_yyexterror");

	sprintf(buf,test,s,t,yytext,yyzeile,yycfgdatei); \
	PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1); \

	return;
}
#endif
