/* Initialisierung des Hauptfensters

											Datei: init_mainwin.c
											Datum: 29.09.1996
											Rev. : 28.12.1997
											Autor: KS

rcs_id: $Id: init_mainwin.c,v 6.0 2000/04/30 12:39:54 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B
*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"

int init_mainwin( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PtArg_t args[1];
	PhArea_t *area;
	PhDim_t neudim;

	/* Wenn Post-realize, die entsprechenden Funktionen aufrufen */
	if (apinfo->reason == ABR_POST_REALIZE) {
		time_t zeit;
		struct tm ltime;

		time(&zeit);
		ltime = *localtime(&zeit);

		/* Ist mal wieder ein Weihnachtsgru fllig? */
		if ((ltime.tm_mon == 11) && (ltime.tm_mday > 24) && (konfigdaten.letzter_weihnachtsgruss < ltime.tm_year)) {
			/* Weihnachtsgru: Nach dem 24. Dezember und vor dem Jahreswechsel */
			konfigdaten.letzter_weihnachtsgruss = ltime.tm_year;
			write_datafile(); /* Neues Datum abspeichern */
			ApCreateModule(ABM_weihnachten_dlg,NULL,NULL);
		}

		return Pt_CONTINUE; /* Weiter geht's */
	}

	/* Hier folgt die "ganz normale" Setupfunktion (d.h. Pre-Realize) */

	/* Ganz am Anfang die Copyrightmeldung ausgeben */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,MSG_COPYRIGHT,0);
	PtSetResources(ABW_output,1,args);

	/* In den Nichtverbunden-Status bringen */
	do_disconnect();

	/* Erst mal die Groesse des Hauptfensters holen, um die Relationen
	   feststellen zu koennen */
	PtSetArg(&args[0],Pt_ARG_AREA,&area,0);
	PtGetResources(ABW_base,1,args);
	memcpy(&neudim,&(konfigdaten.area.size),sizeof(PhDim_t));
	memcpy(&(konfigdaten.area.size),&(area->size),sizeof(PhDim_t));

	/* Die Position des Hauptfensters holen */
	if (konfigdaten.area.pos.x != -1) {
		PtSetArg(&args[0],Pt_ARG_POS,&konfigdaten.area.pos,0);
		PtSetResources(ABW_base,1,args);
	}
	else {
		memcpy(&(konfigdaten.area.pos),&(area->size),sizeof(PhPoint_t));
	}

	/* Die Groesse des Hauptfensters festlegen */
	if (neudim.w != 0) {
		PtSetArg(&args[0],Pt_ARG_DIM,&neudim,0);
		PtSetResources(ABW_base,1,args);
		resize_msg(neudim);
	}

	return( Pt_CONTINUE );
}
