/* Fehler- usw Meldungen

										Datei: msg.h
										Datum: 20.09.1996
										Rev. : 29.12.1997
										Rev.2: 30.04.2000
										Autor: KS

rcs_id: $Id: msg.h,v 6.1 2000/04/30 14:56:11 klaus Exp klaus $

*/

#ifndef __MSG_H_INCLUDED__
#define __MSG_H_INCLUDED__

#define APP_NAME  "KonnMuck" /* Titel bei Fehlermeldungen */
#define FEHLER_SCHRIFT konfigdaten.fehlerschrift /* Schriftart in den Fehlermeldungsfenstern */
#define DEF_FEHLER_SCHRIFT "time12" /* Wenn's noch keine eingelesenen Daten gibt */


/* Normale Meldungen (erscheinen im Ausgabefenster) */
#define MSG_COPYRIGHT "KonnMuck (c) 1996, 2000 by Klaus Schneider\n"
#define MSG_CONNECT     ApGetTextRes(textdb,"@msg_connect") /* "Verbinde zu %s...\n", Hostname */
#define MSG_OPEN        ApGetTextRes(textdb,"@msg_open") /* "Verbunden mit %s\n", Hostname */
#define MSG_CLOSE       ApGetTextRes(textdb,"@msg_close") /* "Verbindung beendet.\n" */
#define MSG_F_ENDE      "\n" /* Was an F_xxx Meldungen angehngt wird,
                                wenn die im Ausgabefenster ausgegeben
						        werden
							    (sollte auf jeden Fall ein '\n' beinhalten,
							    weil die Fehlermeldungen nicht mit '\n'
							    abgeschlossen sind) */

/* Meldungen (erscheinen im Dialogfenster) */
#define MSG_FILE_SENT ApGetTextRes(textdb,"@msg_file_sent") /* "Die Kommandos in der Datei wurden gesendet." */


/* Symbolische Bezeichner fr die Strings */
#define IV_MSG_CONNECT 1
#define IV_MSG_OPEN    2
#define IV_MSG_CLOSE   3


/* Fehlermeldungen */
#define F_FATAL_DBASE "Fatal Error: Couldn't open internal String database!" /* Immer als String definiert: Hier gibt es noch keine Stringdatenbank (sollte eigentlich nicht vorkommen) */
#define F_SPEICHER    ApGetTextRes(textdb,"@f_speicher") /* "Zu wenig Speicherplatz!" */
#define F_HOST        ApGetTextRes(textdb,"@f_host")     /* "%s: Unbekannter Host", Hostname */
#define F_SOCKET      ApGetTextRes(textdb,"@f_socket")   /* "Socket kann nicht geoeffnet werden: %s", strerror(errno) */
#define F_CONNECT     ApGetTextRes(textdb,"@f_connect")  /* "connect: %s", strerror(errno) */
#define F_WRITE       ApGetTextRes(textdb,"@f_write")    /* "write: %s", strerror(errno) */
#define F_READ        ApGetTextRes(textdb,"@f_read")     /* "read: %s", strerror(errno) */
#define F_PROGAUFRUF  ApGetTextRes(textdb,"@f_progaufruf") /* "%s kann nicht ausgefuehrt werden !", Programmname */
#define F_PROGRAMM    ApGetTextRes(textdb,"@f_programm") /* "%s ist nicht das richtige Programm!", Programmname */
#define F_MELDUNG     ApGetTextRes(textdb,"@f_meldung")  /* "Kaputte Meldung erhalten!" */
#define F_MSGID       ApGetTextRes(textdb,"@f_msgid")    /* "Falsche Meldungs-Id erhalten!" */
#define F_BEENDEN     ApGetTextRes(textdb,"@f_beenden")  /* "Prozess %d konnte nicht normal beendet werden!", Pid */
#define F_KONFIGDATEI ApGetTextRes(textdb,"@f_konfigdatei") /* "Konfigurationsdatei %s konnte nicht gelesen werden!", Konfigurationsdateiname */
#define F_LOGDATEI    ApGetTextRes(textdb,"@f_logdatei") /* "Logdatei %s konnte nicht geffnet werden: %s!", Dateiname, strerror(errno) */
#define F_DATEI       ApGetTextRes(textdb,"@f_datei")    /* "Datei '%s' konnte nicht geffnet werden: %s!", Dateiname, strerror(errno) */
#define F_CREATE      ApGetTextRes(textdb,"@f_create")   /* "Datei '%s' kann nicht erstellt werden: %s!", Dateiname, strerror(errno) */
#define F_SERVICE     ApGetTextRes(textdb,"@f_service")  /* "Unbekannter Internetservice '%s'", service */
#define F_GETSOCKNAME ApGetTextRes(textdb,"@f_getsockname") /* "getsockname: %s", strerror(errno) */
#define F_CHMOD       ApGetTextRes(textdb,"@f_chmod")    /* "Dateirechte von %s konnten nicht gendert werden: %s!",dateiname,strerror(errno) */

/* Symbolische Konstanten fr die Fehlermeldungen */
#define IV_F_CONNECT   -2
#define IV_F_READ      -3


/* Meldungen bei den Fehlerfunktionen von Lex/Yacc */
#define F_YY_YYERROR    ApGetTextRes(textdb,"@f_yy_yyerror")    /* "Fehler: %s bei \"%s\"\n in Zeile %d von '%s'",s,yytext,yyzeile,yycfgdatei */
#define F_YY_YYEXTERROR ApGetTextRes(textdb,"@f_yy_yyexterror") /* "Fehler: %s '%s'bei \"%s\"\n in Zeile %d von '%s'",s,t,yytext,yyzeile,yycfgdatei */
#define F_YY_WARNING    ApGetTextRes(textdb,"@f_yy_warning")    /* "Warnung: %s bei \"%s\"\n in Zeile %d von '%s'",s,yytext,yyzeile,yycfgdatei */

/* Tasteraufschriften */
#define TASTER_OK         ApGetTextRes(textdb,"@taster_ok") /* "&Ok" */
#define TASTER_SCHLIESSEN ApGetTextRes(textdb,"@taster_schliessen") /* "Verbindung &schliessen" */
#define TASTER_BEENDEN    ApGetTextRes(textdb,"@taster_beenden") /* "&Beenden" */
#define DEF_TASTER_BEENDEN "&Beenden" /* Immer als String; hier gibt's noch keine Stringdatenbank */

/* Muck-Kommandos */
#define COMMAND_LOGIN konfigdaten.logincmd
#define DEFAULT_LOGIN_CMD "connect %s %s" /* Charakter, Passwort */
#define COMMAND_RETURN '\n' /* Return charakter */
#define COMMAND_RETURN_STRING "\n" /* Return charakter */

/* "Anderes" - Eintrag in der Mudliste */
#define MUCKS_NONE ApGetTextRes(textdb,"@mucks_none") /* "<Anderes>" */


/* Namen in der Konfigurationsdatei */
#define K_X             "X"             /* "X" */
#define K_Y             "Y"             /* "Y" */
#define K_HOEHE         "Height"        /* "Hoehe" */
#define K_BREITE        "Width"         /* "Breite" */
#define K_NORMALSCHRIFT "Outputfont"    /* Normalschriftart" */
#define K_EINGSCHRIFT   "Inputfont"     /* "Eingabeschriftart" */
#define K_MSGSCHRIFT    "Messagefont"   /* "Meldungsschriftart" */
#define K_FEHLERSCHRIFT "Errorfont"     /* "Fehlerschriftart" */
#define K_SPRACHE       "Language"      /* "Sprache" */
#define K_CONNECT       "ConnectString" 
/* In den Muckabschnitten */
#define K_HOST          "Host"      /* "Host" */
#define K_PORT          "Port"      /* "Port" */
#define K_CHARAKTER     "Character" /* "Charakter" */
#define K_PASSWORT      "Password"  /* "Passwort" */
#define K_LOGFILE       "Logfile"   /* "Logdatei" */


/* Fehlermeldungsfunktionen fuer das lex/yacc Programm */
#define __YY_EXT_YYERROR__ \
	sprintf(buf,F_YY_YYERROR,s,yytext,yyzeile,yycfgdatei); \
	PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1); \

#define __YY_EXT_YYEXTERROR__ \
	sprintf(buf,F_YY_YYEXTERROR,s,t,yytext,yyzeile,yycfgdatei); \
	PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1); \

/* test_yy_exterror(s,t,yytext,yyzeile,yycfgdatei); */

#define __YY_EXT_WARNING__ \
	sprintf(buf,F_YY_WARNING,s,yytext,yyzeile,yycfgdatei); \
	PtAskQuestion(ABW_base,APP_NAME,buf,DEF_FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1); \

#endif /* __MSG_H_INCLUDED__ */
