/* Verbindung zu einem MUCK ffnen

								Datei: open_con.c
								Datum: 01.09.1996
								Rev. : 26.04.1997
								Autor: KS

rcs_id: $Id: open_con.c,v 4.21 1997/04/27 12:12:17 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B
*/

//#define DEBUG

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <pwd.h>        /* getpwnam() */
#include <process.h>    /* spawnl() */
#include <sys/types.h>  /* waitpid(), getpwnam(), TCP/IP Bibliothek */
#include <sys/wait.h>   /* waitpid() */
#include <sys/kernel.h> /* Send() */
/* TCP/IP */
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"

int open_con( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PtArg_t args[1];
	char *muckname,*host,*port,*charakter;
	char *logdatei;
	unsigned long *flags;
	unsigned short *indexes;
	int retval;


	/* Werte holen */

	/* Host */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&host,0);
	PtGetResources(ABW_host,1,args);
	/* Port */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&port,0);
	PtGetResources(ABW_port,1,args);
	/* Charaktername */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&charakter,0);
	PtGetResources(ABW_charakter,1,args);
	/* Passwort ist im char-Feld "muckpasswort" enthalten */
	/* Sollen die Kommandos mitgeschnitten werden? */
	PtSetArg(&args[0],Pt_ARG_FLAGS,&flags,0);
	PtGetResources(ABW_DoLog,1,args);
	/* Wenn Mitschnitt, Logdatei holen */
	if (*flags & Pt_SET) {
		PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&logdatei,0);
		PtGetResources(ABW_logfile,1,args);
	}
	else {
		logdatei = NULL;
	}
	/* Ob das Ausgabefenster gelscht werden soll */
	PtSetArg(&args[0],Pt_ARG_FLAGS,&flags,0);
	PtGetResources(ABW_clear,1,args);
	/* Mucknamen */
	PtSetArg(&args[0],Pt_ARG_SELECTION_INDEXES,&indexes,0);
	PtGetResources(ABW_mucks,1,args);
	muckname = (indexes[0] > mucks.muckanz) ? NULL : mucks.muckdaten[(indexes[0]-1)].name;
	
	/* Wenn Mitschnitt gewollt, Logdatei ffnen */
	if (verbindung.fpLog) {
		/* Noch nicht geschlossen - wo ist hier der Programmierfehler ? */
		fclose(verbindung.fpLog);
		verbindung.fpLog = NULL;
	}
	if ((logdatei) && ((verbindung.fpLog = fopen(logdatei,"ab")) == NULL)) {
		/* Konnte nicht geffnet werden */
		sprintf(buf,F_LOGDATEI,logdatei,strerror(errno));
		PtAskQuestion(ABW_open_dlg,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
	}

	/* Verbindung ffnen -------------------------------------------- */	
	if ((retval = open_connection(host,atoi(port),charakter,muckpasswort)) != Pt_CONTINUE) {
		/* Logdatei schliessen, falls offen */
		if (verbindung.fpLog) {
			fclose(verbindung.fpLog);
			verbindung.fpLog = NULL;
		}
		/* Mit Fehlercode zurck */
		return retval;
	}

	/* Hat geklappt ------------------------------------------------- */

	/* Wenn alles im Ausgabefenster gelscht werden soll ------------------ */
	if (*flags & Pt_SET) {
		PtMultiTextModifyText(ABW_output,0,AUSGENDE,0,MSG_COPYRIGHT,strlen(MSG_COPYRIGHT),NULL,0);
	}

	do_connect(muckname);

	return retval;
}

int open_connection(char *host,int port,char *charakter,char *passwd)
{
	struct hostent *hp;
	int ecode,len;
	CONNECT_MELDUNG *meldung;

	/* Zielhost holen */
	if ((hp = gethostbyname(host)) == NULL) {
		sprintf(buf,F_HOST,host);
		PtAskQuestion(ABW_open_dlg,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		return Pt_HALT;
	}

	/* Socket aufmachen */
	if ((verbindung.sock = socket(AF_INET,SOCK_STREAM,0)) < 0) {
		sprintf(buf,F_SOCKET,strerror(errno));
		PtAskQuestion(ABW_open_dlg,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		verbindung.sock = -1;
		return Pt_HALT;
	}

	#ifdef DEBUG
	printf("open_con(): Socket geffnet\n");
	#endif

	/* Verbindungsprozess starten */
	if ((prozessdaten.connect_pid = spawnl(P_NOWAIT,prozessdaten.connect_pfad,CONNECT_FUNK,NULL)) == -1) {
		sprintf(buf,F_PROGAUFRUF,prozessdaten.connect_pfad);
		PtAskQuestion(ABW_open_dlg,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_SCHLIESSEN,NULL,NULL,1);
		close(verbindung.sock); /* Verbindung wieder schliessen */
		verbindung.sock = -1;
		return Pt_HALT;
	}

	/* Erst mal Prozess prfen und den Prozess Speicherplatz allokieren lassen ---------------- */
	meldung = (CONNECT_MELDUNG *)buf;
	INIT_MELDUNG(meldung,KM_OPENSOCK);
	Send(prozessdaten.connect_pid,meldung,meldung,sizeof(MELDUNG),sizeof(MELDUNG));
	if (!KENNUNG_OKAY(meldung)) {
		PtAskQuestion(ABW_open_dlg,APP_NAME,F_MELDUNG,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		close(verbindung.sock); /* Verbindung wieder schlieen */
		verbindung.sock = -1;
	}
	else if (meldung->typ == KM_FEHLER) {
		PtAskQuestion(ABW_open_dlg,APP_NAME,F_SPEICHER,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		close(verbindung.sock); /* Verbindung wieder schlieen */
		verbindung.sock = -1;
	}
	if (verbindung.sock < 0) { /* Fehler (s.o.) */
		/* Warten, bis der Empfangsprozess beendet ist */
		waitpid(prozessdaten.connect_pid,&ecode,0);
		prozessdaten.connect_pid = -1;
		if (!WIFEXITED(ecode)) {
			sprintf(buf,F_BEENDEN,prozessdaten.connect_pid);
			PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		}
		return Pt_HALT;
	}

	#ifdef DEBUG
	printf("open_con(): Verbindungsprozess erfolgreich gestartet und kommuniziert\n");
	#endif
	
	/* Daten senden ------------------------------------------------------- */
	meldung->sock = verbindung.sock;
	meldung->hostaddroffset = 0;
	memcpy(meldung->string,hp->h_addr,hp->h_length);
	len = meldung->h_length = hp->h_length;
	meldung->h_addrtype = hp->h_addrtype;
	/* Hostname */
	meldung->hostnamenoffset = len;
	strcpy(meldung->string+len,hp->h_name);
	len += (strlen(hp->h_name)+1); /* Alle Lngen +1 wegen des '\0's */
	/* Port */
	meldung->port = port;
	/* Charaktername */
	meldung->namenoffset = len;
	strcpy(meldung->string+len,charakter);
	len += (strlen(charakter)+1);
	/* Charakterpasswort */
	meldung->passwdoffset = len;
	strcpy(meldung->string+len,passwd);
	len += (strlen(passwd)+1);

	Send(prozessdaten.connect_pid,meldung,meldung,sizeof(CONNECT_MELDUNG)+len,sizeof(CONNECT_MELDUNG)+BUFLEN);
	if (!KENNUNG_OKAY(meldung)) {
		PtAskQuestion(ABW_open_dlg,APP_NAME,F_MELDUNG,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		close(verbindung.sock); /* Verbindung wieder schlieen */
		verbindung.sock = -1;
	}
	else if (meldung->typ == KM_FEHLER) {
		PtAskQuestion(ABW_open_dlg,APP_NAME,meldung->string,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		close(verbindung.sock); /* Verbindung wieder schlieen */
		verbindung.sock = -1;
	}
	if (verbindung.sock < 0) { /* Fehler (s.o.) */
		/* Warten, bis der Empfangsprozess beendet ist */
		waitpid(prozessdaten.connect_pid,&ecode,0);
		prozessdaten.connect_pid = -1;
		if (!WIFEXITED(ecode)) {
			sprintf(buf,F_BEENDEN,prozessdaten.connect_pid);
			PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		}
		return Pt_HALT;
	}

	#ifdef DEBUG
	printf("open_con(): Verbindungsfunktion erfolgreich gestartet!!\n");
	#endif

	/* Die ausgabe() - Funktion als Eventhander fr alle Meldungen des ---- */
	/* Verbindungsprozesses
	   (es kann erst wieder was empfangen werden, wenn diese Funktion
	    zurckgekehrt ist) */
	prozessdaten.ipid = PtAppAddInput(NULL,prozessdaten.connect_pid,ausgabe,NULL);


	return( Pt_CONTINUE );
}
