/* Aktualisieren der Editierfelder beim Anklicken eines Listeneintrags
   im Verbindung-oeffnen - Dialog von KonnMuck
   sowie beim Anwhlen eines Dateinamens im Dateiauswahlfenster

											Datei: open_listselect.c
											Datum: 12.10.1996
											Rev. : 31.12.1996
											Autor: KS

rcs_id: $Id: open_listselect.c,v 4.0 1997/01/04 12:23:07 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B
*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"

int open_listselect( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PtListCallback_t *selinfo = cbinfo->cbdata;
	PtArg_t args[1];
	char *zeig;
	int len,ind;
	/* Muckdaten */
	char *host,*charakter,*passwort,*logdatei;
	int port;

	if (cbinfo->reason_subtype != Pt_LIST_SELECTION_FINAL) {
		/* Wenn nicht ein Eintrag angeklickt, nichts machen */
		return Pt_CONTINUE;
	}

	#ifdef DEBUG
	printf("konnmuck: Listeneintrag angewaehlt, Pos. %d\n",selinfo->item_pos);
	#endif

	/* Die Daten des angeklickten Mucks in die Dialogfelder uebertragen */

	if (selinfo->item_pos > mucks.muckanz) { /* <Anderes> - Eintrag */
		host      = NULL;
		port      = 0;
		charakter = NULL;
		passwort  = NULL;
		logdatei  = NULL;
	}
	else {
		host      = mucks.muckdaten[selinfo->item_pos-1].host;
		port      = mucks.muckdaten[selinfo->item_pos-1].port;
		charakter = mucks.muckdaten[selinfo->item_pos-1].charaktername;
		passwort  = mucks.muckdaten[selinfo->item_pos-1].passwort;
		logdatei  = mucks.muckdaten[selinfo->item_pos-1].logfile;
	}

	/* Host */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,host,0);
	PtSetResources(ABW_host,1,args);

	/* Port */
	if (port == 0) {
		*buf = '\0';
	}
	else {
		itoa(port,buf,10);
	}
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(ABW_port,1,args);

	/* Charaktername */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,charakter,0);
	PtSetResources(ABW_charakter,1,args);

	/* Passwort */
	if (passwort) {
		len = strlen(passwort);
		if (len >= PASSWDLEN)
			len = PASSWDLEN-1;
		memcpy(muckpasswort,passwort,len);
		*(muckpasswort+len) = '\0';
		for(ind=0,zeig=buf;ind<len;zeig++,ind++) { /* Widget mit Sternen */
			*zeig = '*';
		}
		*zeig = '\0';
		zeig = buf;
	}
	else {
		zeig = NULL;
	}
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,zeig,0);
	PtSetResources(ABW_passwd,1,args);
	
	/* Logdatei */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,logdatei,0);
	PtSetResources(ABW_logfile,1,args);
	PtSetArg(&args[0],Pt_ARG_FLAGS,(logdatei == NULL) ? 0 : Pt_SET,Pt_SET);
	PtSetResources(ABW_DoLog,1,args);

	return Pt_CONTINUE;
}

int dateiauswahl(PtWidget_t *widget,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	PtArg_t args[1];
	AwFileSelectCallback_t *fs = cbinfo->cbdata;
	int len = strlen(fs->dirpath);

	/* Richtigen String erstellen */
	if (len > 0)  {
		if (*(fs->dirpath+len-1) == '/') {
		  sprintf(buf,"%s%s",fs->dirpath,fs->filename);
		}
		else {
		  sprintf(buf,"%s/%s",fs->dirpath,fs->filename);
		}
	}
	else {
		sprintf(buf,"%s/%s",fs->dirpath,fs->filename);
	}

	/* Und setzen */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,buf,0);
	PtSetResources(ABW_logfile,1,args);
	return Pt_CONTINUE;
}
