/* Sendet ein Kommando zum MUCK-Server

										Datei: send_command.c
										Datum: 30.08.1996
										Rev. : 07.04.1997
										Autor: KS

rcs_id: $Id: send_command.c,v 4.11 1997/04/25 13:58:08 klaus Exp klaus $

						AppBuilder Photon Code Lib
						Version 1.11B
*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "header.h"
#include "abimport.h"
#include "proto.h"

int send_command( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PtArg_t args[1];
	char *command;
	char *items[1];

	/* Gibt es berhaupt eine Verbindung? */
	if (verbindung.sock < 0)
		return Pt_CONTINUE;

	/* Wurde nur das Editierfeld angeklickt? */
	if ((widget == ABW_command) && (cbinfo->reason_subtype != Pt_EDIT_ACTIVATE)) {
		return Pt_CONTINUE; /* Ja, ohne Auswirkungen zurck */
	}

	/* Es wurde entweder im Editierfeld ENTER gedrckt oder der Senden-Taster angeklickt */

	/* Kommando holen */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,&command,0);
	PtGetResources(ABW_command,1,args);

	/* Kommando senden */
	do_command(command,DC_AUSGABE);

	/* In die Liste hinzufgen */
	items[0] = command;
	PtListAddItems(ABW_command,items,1,1); /* In Position 1 */

	/* Alles im Editierfeld lschen */
	command = NULL;
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,command,0);
	PtSetResources(ABW_command,1,args);

	return Pt_CONTINUE;
}

int selected(PtWidget_t *widget,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	PtListCallback_t *selinfo = cbinfo->cbdata;
	PtArg_t args[1];

	if (cbinfo->reason_subtype != Pt_LIST_SELECTION_FINAL) {
		/* Wenn nicht ein Eintrag angeklickt, nichts machen */
		return Pt_CONTINUE;
	}

	/* Text setzen */
	PtSetArg(&args[0],Pt_ARG_TEXT_STRING,selinfo->item,0);
	PtSetResources(ABW_command,1,args);

	return Pt_CONTINUE;
}

int send_file(PtWidget_t *widget,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	FILE *fp;
	char *zeig = buf + BUFLEN/2;
	char *ptr;

	AwFileSelectCallback_t *fs = cbinfo->cbdata;
	int len = strlen(fs->dirpath);

	/* Richtigen String erstellen */
	if (len > 0)  {
		if (*(fs->dirpath+len-1) == '/') {
		  sprintf(buf,"%s%s",fs->dirpath,fs->filename);
		}
		else {
		  sprintf(buf,"%s/%s",fs->dirpath,fs->filename);
		}
	}
	else {
		sprintf(buf,"%s/%s",fs->dirpath,fs->filename);
	}

	if ((fp = fopen(buf,"rb")) == NULL) {
		sprintf(zeig,F_DATEI,buf,strerror(errno));
		PtAskQuestion(ABW_base,APP_NAME,zeig,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		return Pt_CONTINUE;
	}

	/* Alle Zeilen durchlaufen (danach sind alle Kommandos ausgelesen) */
	while(fgets(zeig,BUFLEN/2,fp) != NULL) {
		/* Abschlieende '\n's und '\r's weg */
		for(ptr=zeig;*ptr != '\0' && *ptr != '\n' && *ptr != '\r';ptr++);
		*ptr = '\0';
		/* Kommando wegschicken */
		do_command(zeig,DC_AUSGABE);
	}

	/* Fertig */
	PtAskQuestion(ABW_base,APP_NAME,MSG_FILE_SENT,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);

	return Pt_CONTINUE;
}

int send_file_setup(PtWidget_t *link_instance,ApInfo_t *apinfo,PtCallbackInfo_t *cbinfo)
{
	return Pt_CONTINUE;
}

void do_command(char *command,unsigned int mode)
{
	int len;

	if (verbindung.sock < 0)
		return;

	sprintf(buf,"%s%c",command,COMMAND_RETURN);
	len = strlen(buf);

	if (mode == DC_AUSGABE) { /* Mit Ausgabe */
		log_command(buf);
		AddString(buf,KOMMANDO);
	}

	if (write(verbindung.sock,buf,len) == -1) {
		close(verbindung.sock);
		verbindung.sock = -1;
		sprintf(buf,F_WRITE,strerror(errno));
		PtAskQuestion(ABW_base,APP_NAME,buf,FEHLER_SCHRIFT,TASTER_OK,NULL,NULL,1);
		strcat(buf,MSG_F_ENDE);
		strcat(buf,MSG_CLOSE);
		AddString(buf,LOKAL);
		return;
	}
	return;
}
