/* Funktion, die 
   - beim Schlieen des Hauptfensters alles zum Beenden notwendige 
     unternimmt
   - das Gre ndern erledigt

										Datei: winmsg.c
										Datum: 01.09.1996
										Rev. : 25.04.1997
										Autor: KS

rcs_id: $Id: winmsg.c,v 4.20 1997/04/26 11:29:11 klaus Exp klaus $

                            AppBuilder Photon Code Lib
                                         Version 1.11B
*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h> /* shutdown() */

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "config.h"
#include "header.h"
#include "abimport.h"
#include "proto.h"


int winmsg( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PhWindowEvent_t *we = cbinfo->cbdata;
	
	/* Nach Events sortieren */
	switch(we->event_f) {
		case Ph_WM_CLOSE:
			return close_msg();
		case Ph_WM_RESIZE:
		case Ph_WM_MAX:
		case Ph_WM_RESTORE:
			return resize_msg(we->size);
		case Ph_WM_MOVE:
			return move_msg(we->pos);
		default:
			/* Alle anderen Meldungen ignorieren */
			return Pt_CONTINUE;
	}
}

/* Verarbeiten des WM_CLOSE events */
int close_msg(void)
{
	if (verbindung.sock >= 0) {
		/* Verbindung beenden */
		shutdown(verbindung.sock,2);
		verbindung.sock = -1;
		
		/* Logdatei schlieen */
		if (verbindung.fpLog) {
			fclose(verbindung.fpLog);
			verbindung.fpLog = NULL;
		}
		
		/* Alle weiteren Prozesse runterfahren */
		prozesse_runterfahren();
	}

	/* Speicherplatz freigeben */	
	ApCloseDBase(textdb); /* Meldungen fr Mehrsprachen-Untersttzung */
	FREEMUCKLIST(mucks); /* Speicherplatz der Muckliste freigeben */
	free(konfigdaten.cfgdateiname);
	free(prozessdaten.connect_pfad);
	free(prozessdaten.empfangs_pfad);
	free(buf); /* Puffer freigeben */

	/* Beenden */
	return Pt_CONTINUE;
}

/* Verarbeiten von WM_RESIZE, WM_MAX und WM_RESTORE events */
int resize_msg(PhDim_t maindim)
{
	PhDim_t   neudim,*altsize;
	PhPoint_t neupos,*altpos;
	PtArg_t   args[2];

	/* Es wird in folgenden Schritten vorgegangen:
	    Als erstes wird die alte Groesse geholt,
	    um dann die Relationen zu errechnen
	    und schliesslich die neuen Werte zu setzen. */

	/* 1. Das Eingabewidget verschieben */
	PtSetArg(&args[0],Pt_ARG_POS,&altpos,0);
	PtSetArg(&args[1],Pt_ARG_DIM,&altsize,0);
	PtGetResources(ABW_command,2,args);
	/* Schummeln */
	if (altsize->w == 0) altsize->w = 388;
	if (altsize->h == 0) altsize->h = 19;
	/* Das war geschummelt! */
	neupos.x = altpos->x;
	neupos.y = maindim.h - (konfigdaten.area.size.h - altpos->y);
	PtSetArg(&args[0],Pt_ARG_POS,&neupos,0);
	neudim.h = altsize->h;
	neudim.w = maindim.w - (konfigdaten.area.size.w - altsize->w);
	PtSetArg(&args[1],Pt_ARG_DIM,&neudim,0);
	PtSetResources(ABW_command,2,args);

	/* 2. Den "Senden" - Taster verschieben */
	PtSetArg(&args[0],Pt_ARG_POS,&altpos,0);
	PtGetResources(ABW_ok,2,args);
	neupos.x = maindim.w - (konfigdaten.area.size.w - altpos->x);
	/* y-Position ist dieselbe wie beim Eingabewidget */
	PtSetArg(&args[0],Pt_ARG_POS,&neupos,0);
	PtSetResources(ABW_ok,1,args);

	/* 3. Das Ausgabefenster */
	PtSetArg(&args[0],Pt_ARG_DIM,&altsize,0);
	PtGetResources(ABW_output,1,args);
	neudim.w = maindim.w - (konfigdaten.area.size.w - altsize->w);
	neudim.h = maindim.h - (konfigdaten.area.size.h - altsize->h);
	PtSetArg(&args[0],Pt_ARG_DIM,&neudim,0);
	PtSetResources(ABW_output,1,args);

	/* Und die globale Areastruktur aktualiusieren */
	konfigdaten.area.size.h = maindim.h;
	konfigdaten.area.size.w = maindim.w;

	#ifdef DEBUG
	printf("conmuck: Hauptfenster Grosse geaendert\n");
	#endif

	return Pt_CONTINUE;
}

/* Verarbeiten von WM_MOVE events */
int move_msg(PhPoint_t mainpos)
{
	/* Koordinaten sichern */
	konfigdaten.area.pos.x = mainpos.x;
	konfigdaten.area.pos.y = mainpos.y;

	return Pt_CONTINUE;
}
